import { Button, Descriptions, Badge, Popconfirm, Row, Col, Form, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, setDataFieldValue, showApprove, guid, initQueryFilter, ShowDateTime, ShowPrintClose, showFiles } from '../../../utils/common';
import ReactToPrint from 'react-to-print';
import { ExportToExcel } from '@woowalker/feui'
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from 'antd/lib/index';
import styles from '../../../components/CustomPages/HI/StepForm.css';
import config from '../../../config.js';
import FormPage from '../../FormPage'
class BS069ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            btndisplay: 'none',
            isCheck: false, //是否待办 审批
        }
    }

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnExport() {
        let TableWrap = document.getElementById('table1');
        let Table = TableWrap.getElementsByTagName('table1')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, this.props.record.Nav_Department.NAME + '.xlsx')

    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'none' },
            formCode: 'PF123',
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    loadData = (id) => {
        var isCheck = (this.props.data.tableKey != undefined && this.props.data.tableKey == '1') ? true : false
        var orgId = this.props.login ? this.props.login.OrgId : '';
        let json = initFilter(orgId);
        extendRule(json, 'ID', 1, id);
        extendInclude(json, 'Nav_Reject.Nav_User')
        extendInclude(json, 'Nav_Reject')
        extendInclude(json, 'Nav_SafeCheck')
        extendInclude(json, 'Nav_SafeCheck.Nav_CheckType')
        extendInclude(json, 'Nav_SafeCheck.Nav_CheckTypeLevel.Nav_Enums')
        extendInclude(json, 'Nav_CheckProject')
        extendInclude(json, 'Nav_CheckArea')
        extendInclude(json, 'Nav_ListCheckDetailQuestion.Nav_Question')
        extendInclude(json, 'Nav_ListCheckDetailUser.Nav_User')
        this.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'BS/BSSafeCheckDetailReject/GetDetailRejectModel',
            onComplete: (ret) => {
                if (ret) {
                    this.setState({
                        data: ret,
                    })
                }
            }
        });
    }
    render() {
        const { data } = this.state;
        const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        return <div>
            <div style={{ padding: '10px' }}>
                <table>
                    <tr>
                        <td><Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon='export'>审批详情</Button></td>
                        <td><ReactToPrint trigger={() => <Button type={'default'} icon={'printer'} >打印</Button>} content={() => this.componentRef} /></td>
                        <td><ExportToExcel fileName='检查明细' tableId={'tableId' + this.props.data.id} /></td>
                    </tr>
                </table>
            </div>
            <FormPage {...this.state.tmpData} />
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px', paddingTop: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 className={styles.showPrintHead}>检查明细</h1>
                {
                    data ? <div style={{ width: '95%' }}>
                        <Descriptions title='' size='middle' bordered>
                            <Descriptions.Item label="退回人">{data.Nav_Reject?.Nav_User.NAME}</Descriptions.Item>
                            <Descriptions.Item label="退回原因">{data.Nav_Reject?.REASON}</Descriptions.Item>
                            <Descriptions.Item label="附件">{
                                showFiles(data.Nav_Reject.Nav_Files, config.picServerHost)
                            }</Descriptions.Item>
                            <Descriptions.Item label="检查编号">{data.Nav_SafeCheck.CODE}</Descriptions.Item>
                            <Descriptions.Item label="检查类型">{data.Nav_SafeCheck.Nav_CheckType.NAME}</Descriptions.Item>
                            <Descriptions.Item label="检查层级">{data.Nav_SafeCheck.Nav_CheckTypeLevel.Nav_Enums.NAME}</Descriptions.Item>
                            <Descriptions.Item label="检查时间">{data.Nav_SafeCheck.CHECKTIME}</Descriptions.Item>
                            <Descriptions.Item label="检查项目">{data.Nav_CheckProject.NAME}</Descriptions.Item>
                            <Descriptions.Item label="检查区域">{data.Nav_CheckArea.NAME}</Descriptions.Item>
                            <Descriptions.Item label="检查内容">{data.CHECKCONTENT}</Descriptions.Item>
                            <Descriptions.Item label="问题描述">{data.Nav_ListCheckDetailQuestion?.map((item, i) => {
                                return (i > 0 ? ',' : '') + item.Nav_Question.DESCREPTION
                            })}</Descriptions.Item>
                            <Descriptions.Item label="问题等级">{enums.BSQuestionLevelEnum.enums[data.QUESTION_LEVEL]}</Descriptions.Item>
                            <Descriptions.Item label="整改建议与措施">{data.Nav_ListCheckDetailQuestion?.Nav_Question?.DEMAND}</Descriptions.Item>
                            <Descriptions.Item label="检查人员">{data.Nav_ListCheckDetailUser?.map((item, i) => {
                                return (i > 0 ? ',' : '') + item.Nav_User.NAME
                            })}</Descriptions.Item>
                            <Descriptions.Item label="隐患地点">{data.ADDRESS}</Descriptions.Item>
                        </Descriptions>
                    </div> : null
                }
            </div>
        </div>
    }
}
export default connect(({ login, app }) => ({ login, app }))(BS069ShowPrint) 
